///////////////////////////////////////////////////////////
//  APP6BCategorizationData.cs
//  Implementation of the Class APP6BCategorizationData
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:54
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.CategorizationData;
namespace Org.OMG.TACSIT.DataPayload.CategorizationData {
	/// <summary>
	/// The data needed for displaying APP-6B symbol set (see [APP-6B]).
	///        The method to work out the symbol id is to concatenate the attributes
	/// codeScheme, frameShape, functionID, sizeAndMobility, countryCode, orderOfBattle.
	/// 
	/// </summary>
	public class APP6BCategorizationData : MilitaryCategorizationData {

		private char codeScheme;
		private char[] frameShape;
		private char[] functionID;
		private char[] sizeAndMobility;
		private char[] countryCode;
		private char orderOfBattle;
		private String modifiers;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public APP6BCategorizationData(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public APP6BCategorizationData(char the_codeScheme, char[] the_frameShape, char[] the_functionID, char[] the_sizeAndMobility, char[] the_countryCode, char the_orderOfBattle, String the_modifiers){
			codeScheme = the_codeScheme;
			frameShape = the_frameShape;
			functionID = the_functionID;
			sizeAndMobility = the_sizeAndMobility;
			countryCode = the_countryCode;
			orderOfBattle = the_orderOfBattle;
			modifiers = the_modifiers;
		}

		~APP6BCategorizationData(){

		}

		/// <summary>
		/// Code scheme, position 1. This position indicates the overall symbology set to
		/// which a symbol belongs.
		/// </summary>
		public char CodeScheme{
			get{
				return codeScheme;
			}
			set{
				codeScheme = value;
			}
		}

		/// <summary>
		/// Affiliation, battle dimension, and status, 2, 3, and 4. These positions
		/// determine the frame shape of a symbol and indicate its actual or planned
		/// location.
		/// </summary>
		public char[] FrameShape{
			get{
				return frameShape;
			}
			set{
				frameShape = value;
			}
		}

		/// <summary>
		/// Function ID, positions 5 through 10. These positions identify a symbols
		/// function, with each position providing increasing levels of detail and
		/// specialization.
		/// </summary>
		public char[] FunctionID{
			get{
				return functionID;
			}
			set{
				functionID = value;
			}
		}

		/// <summary>
		/// Size/mobility indicator code, positions 11 and 12. These positions identify the
		/// size and mobility of a symbol.
		/// </summary>
		public char[] SizeAndMobility{
			get{
				return sizeAndMobility;
			}
			set{
				sizeAndMobility = value;
			}
		}

		/// <summary>
		/// Country code, positions 13 and 14. These positions identify the country with
		/// which a symbol is associated. Country code identifiers are listed in Federal
		/// Information Processing Standard Pub 10 series (See [FIPS 10-4]).
		/// </summary>
		public char[] CountryCode{
			get{
				return countryCode;
			}
			set{
				countryCode = value;
			}
		}

		/// <summary>
		/// Order of battle, position 15. This position provides additional information
		/// about the role of a symbol in the battlespace. For example, a bomber that has
		/// nuclear weapons on board may be strategic force-related, or a tactical graphic
		/// may also perform the role of a control point.
		/// </summary>
		public char OrderOfBattle{
			get{
				return orderOfBattle;
			}
			set{
				orderOfBattle = value;
			}
		}

		/// <summary>
		/// The semicolon-separated list of Symbol Modifier Fields as defined is [APP6B].
		///          A Symbol Modifier Field is defined as a key-value pair delimited
		///          with the ':' character.
		/// </summary>
		public string Modifiers{
			get{
				return modifiers;
			}
			set{
				modifiers = value;
			}
		}

	}//end APP6BCategorizationData

}//end namespace CategorizationData