///////////////////////////////////////////////////////////
//  APP6CCategorizationData.cs
//  Implementation of the Class APP6CCategorizationData
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:54
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.CategorizationData;
namespace Org.OMG.TACSIT.DataPayload.CategorizationData {
	/// <summary>
	/// The data needed for displaying APP-6C symbol set as described in [APP-6C].
	///        The method to work out the symbol id is to concatenate the attributes.
	/// </summary>
	public class APP6CCategorizationData : MilitaryCategorizationData {

		private char use;
		private char[] version;
		private char[] standardIdentity;
		private char[] symbolSet;
		private char status;
		private char headQuarterTaskForceDummy;
		private char[] amplifier;
		private char[] entity;
		private char[] entityType;
		private char[] entitySubType;
		private char[] sectorOneModifier;
		private char[] sectorTwoModifier;
		private char[] nationalAdditionId;
		private char nationalAdditionVersion;
		private char[] nationalAddition;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public APP6CCategorizationData(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public APP6CCategorizationData(char the_use, char[] the_version, char[] the_standardIdentity, char[] the_symbolSet, char the_status, char the_headQuarterTaskForceDummy, char[] the_amplifier, char[] the_entity, char[] the_entityType, char[] the_entitySubType, char[] the_sectorOneModifier, char[] the_sectorTwoModifier, char[] the_nationalAdditionId, char the_nationalAdditionVersion, char[] the_nationalAddition){
			use = the_use;
			version = the_version;
			standardIdentity = the_standardIdentity;
			symbolSet = the_symbolSet;
			status = the_status;
			headQuarterTaskForceDummy = the_headQuarterTaskForceDummy;
			amplifier = the_amplifier;
			entity = the_entity;
			entityType = the_entityType;
			entitySubType = the_entitySubType;
			sectorOneModifier = the_sectorOneModifier;
			sectorTwoModifier = the_sectorTwoModifier;
			nationalAdditionId = the_nationalAdditionId;
			nationalAdditionVersion = the_nationalAdditionVersion;
			nationalAddition = the_nationalAddition;
		}

		~APP6CCategorizationData(){

		}

		/// <summary>
		/// This one digit field indicates whether the symbol identification code uses the
		/// third ten digit set.
		/// </summary>
		public char Use{
			get{
				return use;
			}
			set{
				use = value;
			}
		}

		/// <summary>
		/// This field identifies a version change for the symbol identification code which
		/// occurs when there is a change in an established icon, modifier, or drawing rule
		/// for a control measure symbol. Subsequent changes will create further version
		/// changes for the symbol identification
		///          code. The basis for all symbol versions in all sets is APP-6(C).
		/// </summary>
		public char[] Version{
			get{
				return version;
			}
			set{
				version = value;
			}
		}

		/// <summary>
		/// Standard identity is comprised of two digits. The first digit represents the
		/// context of the symbol and the second digit reflects the standard identities.
		/// </summary>
		public char[] StandardIdentity{
			get{
				return standardIdentity;
			}
			set{
				standardIdentity = value;
			}
		}

		/// <summary>
		/// The symbol set is comprised of two digits.
		/// </summary>
		public char[] SymbolSet{
			get{
				return symbolSet;
			}
			set{
				symbolSet = value;
			}
		}

		/// <summary>
		/// The status is comprised of one digit.
		/// </summary>
		public char Status{
			get{
				return status;
			}
			set{
				status = value;
			}
		}

		/// <summary>
		/// The Headquarters/Task Force/Dummy is comprised of one digit.
		/// </summary>
		public char HeadQuarterTaskForceDummy{
			get{
				return headQuarterTaskForceDummy;
			}
			set{
				headQuarterTaskForceDummy = value;
			}
		}

		/// <summary>
		/// The Unit Echelon/Equipment Mobility/Naval Towed Array Amplifier is comprised of
		/// two digits.
		/// </summary>
		public char[] Amplifier{
			get{
				return amplifier;
			}
			set{
				amplifier = value;
			}
		}

		public char[] Entity{
			get{
				return entity;
			}
			set{
				entity = value;
			}
		}

		public char[] EntityType{
			get{
				return entityType;
			}
			set{
				entityType = value;
			}
		}

		public char[] EntitySubType{
			get{
				return entitySubType;
			}
			set{
				entitySubType = value;
			}
		}

		public char[] SectorOneModifier{
			get{
				return sectorOneModifier;
			}
			set{
				sectorOneModifier = value;
			}
		}

		public char[] SectorTwoModifier{
			get{
				return sectorTwoModifier;
			}
			set{
				sectorTwoModifier = value;
			}
		}

		/// <summary>
		/// National or geopolitical identifier.
		///          This is to accommodate national modifications/additions that are not
		/// included in APP-6C.
		/// </summary>
		public char[] NationalAdditionId{
			get{
				return nationalAdditionId;
			}
			set{
				nationalAdditionId = value;
			}
		}

		/// <summary>
		/// National or geopolitical symbol set version.
		///          This is to accommodate national modifications/additions that are not
		/// included in APP-6C.
		/// </summary>
		public char NationalAdditionVersion{
			get{
				return nationalAdditionVersion;
			}
			set{
				nationalAdditionVersion = value;
			}
		}

		/// <summary>
		/// Specified by national or geopolitical symbol set.
		///          This is to accommodate national modifications/additions that are not
		/// included in APP-6C.
		/// </summary>
		public char[] NationalAddition{
			get{
				return nationalAddition;
			}
			set{
				nationalAddition = value;
			}
		}

	}//end APP6CCategorizationData

}//end namespace CategorizationData