///////////////////////////////////////////////////////////
//  STANAG5516SymbolCategorizationData.cs
//  Implementation of the Class STANAG5516SymbolCategorizationData
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:58
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.CategorizationData;
namespace Org.OMG.TACSIT.DataPayload.CategorizationData {
	/// <summary>
	/// The data needed to display symbol sets aimed at data models derived from STANAG
	/// 5516. This STANAG does not define symbology. The purpose of this class is to
	/// support custom symbology based on 5516 data model.
	/// </summary>
	public class STANAG5516SymbolCategorizationData : STANAG5516CategorizationData {

		private char hasSpecialProcessing;
		private bool isAnEmergency;
		private bool isOfSpecialInterest;
		private char platformIdentity;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public STANAG5516SymbolCategorizationData(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public STANAG5516SymbolCategorizationData(char the_hasSpecialProcessing, bool the_isAnEmergency, bool the_isOfSpecialInterest, char the_platformIdentity){
			hasSpecialProcessing = the_hasSpecialProcessing;
			isAnEmergency = the_isAnEmergency;
			isOfSpecialInterest = the_isOfSpecialInterest;
			platformIdentity = the_platformIdentity;
		}

		/// <summary>
		/// Constructor with parameters for each mandatory property
		/// </summary>
		public STANAG5516SymbolCategorizationData(char the_hasSpecialProcessing, bool the_isAnEmergency, bool the_isOfSpecialInterest){
			hasSpecialProcessing = the_hasSpecialProcessing;
			isAnEmergency = the_isAnEmergency;
			isOfSpecialInterest = the_isOfSpecialInterest;
		}

		~STANAG5516SymbolCategorizationData(){

		}

		/// <summary>
		/// The Special Processing indicator is set
		/// </summary>
		public char HasSpecialProcessing{
			get{
				return hasSpecialProcessing;
			}
			set{
				hasSpecialProcessing = value;
			}
		}

		/// <summary>
		/// The Emergency indicator is set
		/// </summary>
		public bool IsAnEmergency{
			get{
				return isAnEmergency;
			}
			set{
				isAnEmergency = value;
			}
		}

		/// <summary>
		/// The Special Interest indicator is set
		/// </summary>
		public bool IsOfSpecialInterest{
			get{
				return isOfSpecialInterest;
			}
			set{
				isOfSpecialInterest = value;
			}
		}

		/// <summary>
		/// The code for the per environment defined platform identify for the Entity
		/// according to STANAG 5516. If no identity is defined then the code refers to a
		/// value in the reference point tables within STANAG 5516.
		/// </summary>
		public char PlatformIdentity{
			get{
				return platformIdentity;
			}
			set{
				platformIdentity = value;
			}
		}

	}//end STANAG5516SymbolCategorizationData

}//end namespace CategorizationData