///////////////////////////////////////////////////////////
//  EntityHistoryPayload.cs
//  Implementation of the Class EntityHistoryPayload
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:55
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityHistory {
	/// <summary>
	/// The definition of the history of an entity as it appears in the exchanges with
	/// TACSIT.
	///        Such a history is defined:
	///        - For one entity;
	///        - By a collection of Entity Payloads which are the different states in
	/// the history (as a reminder, an EntityPayload holds a TimeStamp attribute giving
	/// the date of validity of the data).
	/// </summary>
	public class EntityHistoryPayload {

		private IEnumerable<Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload> states;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef reference;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public EntityHistoryPayload(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public EntityHistoryPayload(IEnumerable<Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload> the_states, Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef the_reference){
			states = the_states;
			reference = the_reference;
		}

		/// <summary>
		/// Constructor with parameters for each mandatory property
		/// </summary>
		public EntityHistoryPayload(Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef the_reference){
			reference = the_reference;
		}

		~EntityHistoryPayload(){

		}

		/// <summary>
		/// The list of time-stamped states of the history.
		/// </summary>
		public IEnumerable<Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload> States{
			get{
				return states;
			}
			set{
				states = value;
			}
		}

		/// <summary>
		/// The entity concerned by the history.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef Reference{
			get{
				return reference;
			}
			set{
				reference = value;
			}
		}

	}//end EntityHistoryPayload

}//end namespace EntityHistory