///////////////////////////////////////////////////////////
//  AmbiguousBearings.cs
//  Implementation of the Class AmbiguousBearings
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:07
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// An entity that is know to exist somewhere along a line of one of two angles of
	/// azimuth from an origin (typically the location of a passive towed array sonar),
	/// but there is no information regarding its range (distance from the origin). On
	/// a TACSIT each ambiguous bearing should be represented as a line from the origin
	/// to the edge of the display.
	///        .
	/// </summary>
	public class AmbiguousBearings : ShapedEntity {

		private Org.OMG.TACSIT.DataPayload.Util.Angle bearingA;
		private Org.OMG.TACSIT.DataPayload.Util.Angle bearingB;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate origin;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public AmbiguousBearings(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public AmbiguousBearings(Org.OMG.TACSIT.DataPayload.Util.Angle the_bearingA, Org.OMG.TACSIT.DataPayload.Util.Angle the_bearingB, Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate the_origin){
			bearingA = the_bearingA;
			bearingB = the_bearingB;
			origin = the_origin;
		}

		~AmbiguousBearings(){

		}

		/// <summary>
		/// one of the ambiguous angles of azimuth
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle BearingA{
			get{
				return bearingA;
			}
			set{
				bearingA = value;
			}
		}

		/// <summary>
		/// the other ambiguous angle of azimuth
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle BearingB{
			get{
				return bearingB;
			}
			set{
				bearingB = value;
			}
		}

		/// <summary>
		/// The origin of the ambiguous bearings.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate Origin{
			get{
				return origin;
			}
			set{
				origin = value;
			}
		}

		/// <summary>
		/// Determine whether AmbiguousBearings has a valid origin property.
		/// </summary>
		public bool OriginExists(){

			return (origin != null);
		}

	}//end AmbiguousBearings

}//end namespace EntityPayload