///////////////////////////////////////////////////////////
//  Arc.cs
//  Implementation of the Class Arc
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:07
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// An entity represented as a segment of the outline of an ellipse. It is defined
	/// by the ellipse it is part of and the start and end angle of the arc on that
	/// ellipse. The arc is defined in a clockwise direction from the startangle to the
	/// endangle.
	/// </summary>
	public class Arc : ShapedEntity {

		private Org.OMG.TACSIT.DataPayload.Util.Distance nSSemiAxis;
		private Org.OMG.TACSIT.DataPayload.Util.Distance eWSemiAxis;
		private Org.OMG.TACSIT.DataPayload.Util.Angle startAngle;
		private Org.OMG.TACSIT.DataPayload.Util.Angle endAngle;
		private Org.OMG.TACSIT.DataPayload.Util.Angle rotation;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate center;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public Arc(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public Arc(Org.OMG.TACSIT.DataPayload.Util.Distance the_nSSemiAxis, Org.OMG.TACSIT.DataPayload.Util.Distance the_eWSemiAxis, Org.OMG.TACSIT.DataPayload.Util.Angle the_startAngle, Org.OMG.TACSIT.DataPayload.Util.Angle the_endAngle, Org.OMG.TACSIT.DataPayload.Util.Angle the_rotation, Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate the_center){
			nSSemiAxis = the_nSSemiAxis;
			eWSemiAxis = the_eWSemiAxis;
			startAngle = the_startAngle;
			endAngle = the_endAngle;
			rotation = the_rotation;
			center = the_center;
		}

		~Arc(){

		}

		/// <summary>
		/// The North-South (before rotation) semi-axis of the ellipse. This number should
		/// be positive. The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance NSSemiAxis{
			get{
				return nSSemiAxis;
			}
			set{
				nSSemiAxis = value;
			}
		}

		/// <summary>
		/// The East-West (before rotation) semi-axis of the ellipse. This number should be
		/// positive. The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance EWSemiAxis{
			get{
				return eWSemiAxis;
			}
			set{
				eWSemiAxis = value;
			}
		}

		/// <summary>
		/// The start angle of the arc along an ellipse prior to rotation.
		///          The unit is set by the group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle StartAngle{
			get{
				return startAngle;
			}
			set{
				startAngle = value;
			}
		}

		/// <summary>
		/// The end angle of the arc along an ellipse prior to rotation.
		///          The unit is set by the group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle EndAngle{
			get{
				return endAngle;
			}
			set{
				endAngle = value;
			}
		}

		/// <summary>
		/// Rotation in the counter-clockwise direction.
		///          The unit is set by the group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle Rotation{
			get{
				return rotation;
			}
			set{
				rotation = value;
			}
		}

		/// <summary>
		/// The center of the arc.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate Center{
			get{
				return center;
			}
			set{
				center = value;
			}
		}

	}//end Arc

}//end namespace EntityPayload