///////////////////////////////////////////////////////////
//  Arrow.cs
//  Implementation of the Class Arrow
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:07
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// An entity represented as a polyline.
	/// </summary>
	public class Arrow : ShapedEntity {

		private Org.OMG.TACSIT.DataPayload.Util.Distance width;
		private IList<Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate> points;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public Arrow(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public Arrow(Org.OMG.TACSIT.DataPayload.Util.Distance the_width, IList<Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate> the_points){
			width = the_width;
			points = the_points;
		}

		/// <summary>
		/// Constructor with parameters for each mandatory property
		/// </summary>
		public Arrow(Org.OMG.TACSIT.DataPayload.Util.Distance the_width){
			width = the_width;
		}

		~Arrow(){

		}

		/// <summary>
		/// Width of the arrow body. Width must be greater than zero.
		///          The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance Width{
			get{
				return width;
			}
			set{
				width = value;
			}
		}

		/// <summary>
		/// The points that make up the arrow. The order of points defines the direction
		/// proceeding from tail to point.
		/// </summary>
		public IList<Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate> Points{
			get{
				return points;
			}
			set{
				points = value;
			}
		}

	}//end Arrow

}//end namespace EntityPayload