///////////////////////////////////////////////////////////
//  EntityMetaData.cs
//  Implementation of the Class EntityMetaData
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:08
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// The Meta Data of an Entity.
	/// </summary>
	public class EntityMetaData {

		private String publisher;
		private String identifier;
		private String securityPolicy;
		private String securityClassification;
		private String securityCategory;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public EntityMetaData(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public EntityMetaData(String the_publisher, String the_identifier, String the_securityPolicy, String the_securityClassification, String the_securityCategory){
			publisher = the_publisher;
			identifier = the_identifier;
			securityPolicy = the_securityPolicy;
			securityClassification = the_securityClassification;
			securityCategory = the_securityCategory;
		}

		~EntityMetaData(){

		}

		/// <summary>
		/// The publisher of the entity.
		/// </summary>
		public string Publisher{
			get{
				return publisher;
			}
			set{
				publisher = value;
			}
		}

		/// <summary>
		/// An external identifier for the entity. This identifier is not bound to be
		/// unique among entities.
		/// </summary>
		public string Identifier{
			get{
				return identifier;
			}
			set{
				identifier = value;
			}
		}

		/// <summary>
		/// Type of security Policy (e.g.: NATO).
		/// </summary>
		public string SecurityPolicy{
			get{
				return securityPolicy;
			}
			set{
				securityPolicy = value;
			}
		}

		/// <summary>
		/// Security classification in the preceding policy (e.g. UNCLASSIFED, NATO COSMIC
		/// SECRET).
		/// </summary>
		public string SecurityClassification{
			get{
				return securityClassification;
			}
			set{
				securityClassification = value;
			}
		}

		/// <summary>
		/// Description of the security classification (e.g. "Releasable for Internet
		/// transmission").
		/// </summary>
		public string SecurityCategory{
			get{
				return securityCategory;
			}
			set{
				securityCategory = value;
			}
		}

	}//end EntityMetaData

}//end namespace EntityPayload