///////////////////////////////////////////////////////////
//  GeodeticPosition.cs
//  Implementation of the Class GeodeticPosition
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:08
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// Coordinates in a Geodetic reference frame as described by a coordinate
	/// specification object (from [OARIS]).
	///        The datum (WGS84...) is set by the group.
	/// </summary>
	public class GeodeticPosition : PositionCoordinate {

		private Org.OMG.TACSIT.DataPayload.Util.Angle latitude;
		private Org.OMG.TACSIT.DataPayload.Util.Angle longitude;
		private Org.OMG.TACSIT.DataPayload.Util.Distance altitude;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public GeodeticPosition(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public GeodeticPosition(Org.OMG.TACSIT.DataPayload.Util.Angle the_latitude, Org.OMG.TACSIT.DataPayload.Util.Angle the_longitude, Org.OMG.TACSIT.DataPayload.Util.Distance the_altitude){
			latitude = the_latitude;
			longitude = the_longitude;
			altitude = the_altitude;
		}

		~GeodeticPosition(){

		}

		/// <summary>
		/// Latitude of the point.
		///          The Angle unit as well as the projection are set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle Latitude{
			get{
				return latitude;
			}
			set{
				latitude = value;
			}
		}

		/// <summary>
		/// Longitude of the point.
		///          The Angle unit as well as the projection are set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle Longitude{
			get{
				return longitude;
			}
			set{
				longitude = value;
			}
		}

		/// <summary>
		/// Altitude of the point.
		///          The Distance unit as well as the projection are set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance Altitude{
			get{
				return altitude;
			}
			set{
				altitude = value;
			}
		}

	}//end GeodeticPosition

}//end namespace EntityPayload