///////////////////////////////////////////////////////////
//  Rectangle.cs
//  Implementation of the Class Rectangle
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:08
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// An entity represented as a rectangle.
	/// </summary>
	public class Rectangle : ShapedEntity {

		private Org.OMG.TACSIT.DataPayload.Util.AngleUnit nSHalfDistance;
		private Org.OMG.TACSIT.DataPayload.Util.Distance eWHalfDistance;
		private Org.OMG.TACSIT.DataPayload.Util.Angle rotation;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate center;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public Rectangle(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public Rectangle(Org.OMG.TACSIT.DataPayload.Util.AngleUnit the_nSHalfDistance, Org.OMG.TACSIT.DataPayload.Util.Distance the_eWHalfDistance, Org.OMG.TACSIT.DataPayload.Util.Angle the_rotation, Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate the_center){
			nSHalfDistance = the_nSHalfDistance;
			eWHalfDistance = the_eWHalfDistance;
			rotation = the_rotation;
			center = the_center;
		}

		~Rectangle(){

		}

		/// <summary>
		/// The dimension from center point to edge (half distance) of the rectangle along
		/// its North-South length. This number should be positive.
		///          The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.AngleUnit NSHalfDistance{
			get{
				return nSHalfDistance;
			}
			set{
				nSHalfDistance = value;
			}
		}

		/// <summary>
		/// The dimension from center point to edge (half distance) of the rectangle along
		/// its East-West length. This number should be positive.
		///          The Distance unit is set by the Group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Distance EWHalfDistance{
			get{
				return eWHalfDistance;
			}
			set{
				eWHalfDistance = value;
			}
		}

		/// <summary>
		/// Rotation in the counter-clockwise direction.
		///          The unit is set by the group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle Rotation{
			get{
				return rotation;
			}
			set{
				rotation = value;
			}
		}

		/// <summary>
		/// The coordinates of the center of the rectangle.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate Center{
			get{
				return center;
			}
			set{
				center = value;
			}
		}

	}//end Rectangle

}//end namespace EntityPayload