///////////////////////////////////////////////////////////
//  ShapedEntity.cs
//  Implementation of the Class ShapedEntity
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:09
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.Util;
using Org.OMG.TACSIT.DataPayload.CategorizationData;
using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// The base for most items.
	/// </summary>
	public abstract class ShapedEntity : EntityPayload {

		private Org.OMG.TACSIT.DataPayload.Util.Angle climbAngle;
		private Org.OMG.TACSIT.DataPayload.Util.Angle directionOfMovement;
		private bool isHeadingRelative;
		private Org.OMG.TACSIT.DataPayload.Util.Speed speed;
		private Org.OMG.TACSIT.DataPayload.CategorizationData.CategorizationIn3D categorizationIn3D;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.InterpolationMethodology? legType;
		private Org.OMG.TACSIT.DataPayload.CategorizationData.CategorizationData categorization;
		private IEnumerable<Org.OMG.TACSIT.DataPayload.EntityPayload.ExtendedData> extendedData;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public ShapedEntity(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public ShapedEntity(Org.OMG.TACSIT.DataPayload.Util.Angle the_climbAngle, Org.OMG.TACSIT.DataPayload.Util.Angle the_directionOfMovement, bool the_isHeadingRelative, Org.OMG.TACSIT.DataPayload.Util.Speed the_speed, Org.OMG.TACSIT.DataPayload.CategorizationData.CategorizationIn3D the_categorizationIn3D, Org.OMG.TACSIT.DataPayload.EntityPayload.InterpolationMethodology? the_legType, Org.OMG.TACSIT.DataPayload.CategorizationData.CategorizationData the_categorization, IEnumerable<Org.OMG.TACSIT.DataPayload.EntityPayload.ExtendedData> the_extendedData){
			climbAngle = the_climbAngle;
			directionOfMovement = the_directionOfMovement;
			isHeadingRelative = the_isHeadingRelative;
			speed = the_speed;
			categorizationIn3D = the_categorizationIn3D;
			legType = the_legType;
			categorization = the_categorization;
			extendedData = the_extendedData;
		}

		/// <summary>
		/// Constructor with parameters for each mandatory property
		/// </summary>
		public ShapedEntity(Org.OMG.TACSIT.DataPayload.Util.Angle the_climbAngle, Org.OMG.TACSIT.DataPayload.Util.Angle the_directionOfMovement, bool the_isHeadingRelative, Org.OMG.TACSIT.DataPayload.Util.Speed the_speed, Org.OMG.TACSIT.DataPayload.CategorizationData.CategorizationIn3D the_categorizationIn3D, Org.OMG.TACSIT.DataPayload.EntityPayload.InterpolationMethodology? the_legType, Org.OMG.TACSIT.DataPayload.CategorizationData.CategorizationData the_categorization){
			climbAngle = the_climbAngle;
			directionOfMovement = the_directionOfMovement;
			isHeadingRelative = the_isHeadingRelative;
			speed = the_speed;
			categorizationIn3D = the_categorizationIn3D;
			legType = the_legType;
			categorization = the_categorization;
		}

		~ShapedEntity(){

		}

		/// <summary>
		/// Direction of the movement wrt altitude, if any.
		///          The unit is set by the group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle ClimbAngle{
			get{
				return climbAngle;
			}
			set{
				climbAngle = value;
			}
		}

		/// <summary>
		/// Direction of the movement, if any.
		///          The unit is set by the group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Angle DirectionOfMovement{
			get{
				return directionOfMovement;
			}
			set{
				directionOfMovement = value;
			}
		}

		/// <summary>
		/// Whether the shape is defined relative to the heading (direction of movement) of
		/// the entity
		/// </summary>
		public bool IsHeadingRelative{
			get{
				return isHeadingRelative;
			}
			set{
				isHeadingRelative = value;
			}
		}

		/// <summary>
		/// Speed of movement.
		///          The unit is set by the group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.Util.Speed Speed{
			get{
				return speed;
			}
			set{
				speed = value;
			}
		}

		/// <summary>
		/// Data needed to draw the symbol of the entity in 3D.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.CategorizationData.CategorizationIn3D CategorizationIn3D{
			get{
				return categorizationIn3D;
			}
			set{
				categorizationIn3D = value;
			}
		}

		/// <summary>
		/// Determine whether ShapedEntity has a valid categorizationIn3D property.
		/// </summary>
		public bool CategorizationIn3DExists(){

			return (categorizationIn3D != null);
		}

		/// <summary>
		/// Interpolation method for the shape.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.InterpolationMethodology? LegType{
			get{
				return legType;
			}
			set{
				legType = value;
			}
		}

		/// <summary>
		/// Data needed to draw the symbol of the entity.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.CategorizationData.CategorizationData Categorization{
			get{
				return categorization;
			}
			set{
				categorization = value;
			}
		}

		/// <summary>
		/// Extensible data.
		/// </summary>
		public IEnumerable<Org.OMG.TACSIT.DataPayload.EntityPayload.ExtendedData> ExtendedData{
			get{
				return extendedData;
			}
			set{
				extendedData = value;
			}
		}

	}//end ShapedEntity

}//end namespace EntityPayload