///////////////////////////////////////////////////////////
//  StickyNote.cs
//  Implementation of the Class StickyNote
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:30:09
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.EntityPayload;
namespace Org.OMG.TACSIT.DataPayload.EntityPayload {
	/// <summary>
	/// A note with a handle.
	///        Also know as a Post-It note ("Post-It" is a registered 3M trademark).
	/// </summary>
	public class StickyNote : ShapedEntity {

		private String text;
		private String font;
		private String textColor;
		private String backgroundColor;
		private String borderStyle;
		private int offsetX;
		private int offsetY;
		private Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate point;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public StickyNote(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public StickyNote(String the_text, String the_font, String the_textColor, String the_backgroundColor, String the_borderStyle, int the_offsetX, int the_offsetY, Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate the_point){
			text = the_text;
			font = the_font;
			textColor = the_textColor;
			backgroundColor = the_backgroundColor;
			borderStyle = the_borderStyle;
			offsetX = the_offsetX;
			offsetY = the_offsetY;
			point = the_point;
		}

		~StickyNote(){

		}

		/// <summary>
		/// Text of the note
		/// </summary>
		public string Text{
			get{
				return text;
			}
			set{
				text = value;
			}
		}

		/// <summary>
		/// Font family (aka typeface) used to write the text within the note.
		/// </summary>
		public string Font{
			get{
				return font;
			}
			set{
				font = value;
			}
		}

		/// <summary>
		/// Color of the text in the note.
		///          The way this color is mapped to RGB or other values is implementation
		/// dependent.
		/// </summary>
		public string TextColor{
			get{
				return textColor;
			}
			set{
				textColor = value;
			}
		}

		/// <summary>
		/// Color of the note itself.
		///          The way this color is mapped to RGB or other values is implementation
		/// dependent.
		/// </summary>
		public string BackgroundColor{
			get{
				return backgroundColor;
			}
			set{
				backgroundColor = value;
			}
		}

		/// <summary>
		/// Style of the border of the note.
		///          The way this style is mapped is implementation dependent.
		/// </summary>
		public string BorderStyle{
			get{
				return borderStyle;
			}
			set{
				borderStyle = value;
			}
		}

		/// <summary>
		/// Horizontal gap between the center of the text block and the end of the handle.
		/// In pixels.
		/// </summary>
		public int OffsetX{
			get{
				return offsetX;
			}
			set{
				offsetX = value;
			}
		}

		/// <summary>
		/// Vertical gap between the center of the text block and the end of the handle. In
		/// pixels.
		/// </summary>
		public int OffsetY{
			get{
				return offsetY;
			}
			set{
				offsetY = value;
			}
		}

		/// <summary>
		/// Location of the end of the handle.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.EntityPayload.PositionCoordinate Point{
			get{
				return point;
			}
			set{
				point = value;
			}
		}

	}//end StickyNote

}//end namespace EntityPayload