///////////////////////////////////////////////////////////
//  GroupMetaData.cs
//  Implementation of the Class GroupMetaData
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:56
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.GroupPayload;
namespace Org.OMG.TACSIT.DataPayload.GroupPayload {
	/// <summary>
	/// The Meta Data of a group: these metadata apply by default to all the entities
	/// of the group.
	///        These data include the units which are used in all the attributes of all
	/// the entities of the group.
	/// </summary>
	public class GroupMetaData {

		private String publisher;
		private String identifier;
		private String securityPolicy;
		private String securityClassification;
		private String securityCategory;
		private bool readOnly;
		private String category;
		private Org.OMG.TACSIT.DataPayload.GroupPayload.CoordinateUnits unitsMetaData;
		private IEnumerable<Org.OMG.TACSIT.DataPayload.GroupPayload.ExtensionSchema> schemas;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public GroupMetaData(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public GroupMetaData(String the_publisher, String the_identifier, String the_securityPolicy, String the_securityClassification, String the_securityCategory, bool the_readOnly, String the_category, Org.OMG.TACSIT.DataPayload.GroupPayload.CoordinateUnits the_unitsMetaData, IEnumerable<Org.OMG.TACSIT.DataPayload.GroupPayload.ExtensionSchema> the_schemas){
			publisher = the_publisher;
			identifier = the_identifier;
			securityPolicy = the_securityPolicy;
			securityClassification = the_securityClassification;
			securityCategory = the_securityCategory;
			readOnly = the_readOnly;
			category = the_category;
			unitsMetaData = the_unitsMetaData;
			schemas = the_schemas;
		}

		/// <summary>
		/// Constructor with parameters for each mandatory property
		/// </summary>
		public GroupMetaData(String the_publisher, String the_identifier, String the_securityPolicy, String the_securityClassification, String the_securityCategory, bool the_readOnly, String the_category, Org.OMG.TACSIT.DataPayload.GroupPayload.CoordinateUnits the_unitsMetaData){
			publisher = the_publisher;
			identifier = the_identifier;
			securityPolicy = the_securityPolicy;
			securityClassification = the_securityClassification;
			securityCategory = the_securityCategory;
			readOnly = the_readOnly;
			category = the_category;
			unitsMetaData = the_unitsMetaData;
		}

		~GroupMetaData(){

		}

		/// <summary>
		/// The publisher of the group.
		/// </summary>
		public string Publisher{
			get{
				return publisher;
			}
			set{
				publisher = value;
			}
		}

		/// <summary>
		/// An external identifier for the group. This identifier is not bound to be unique
		/// among groups.
		/// </summary>
		public string Identifier{
			get{
				return identifier;
			}
			set{
				identifier = value;
			}
		}

		/// <summary>
		/// Type of security Policy (e.g.: NATO).
		/// </summary>
		public string SecurityPolicy{
			get{
				return securityPolicy;
			}
			set{
				securityPolicy = value;
			}
		}

		/// <summary>
		/// Security classification in the preceding policy (e.g. UNCLASSIFED, NATO COSMIC
		/// SECRET).
		/// </summary>
		public string SecurityClassification{
			get{
				return securityClassification;
			}
			set{
				securityClassification = value;
			}
		}

		/// <summary>
		/// Description of the security classification (e.g. "Releasable for Internet
		/// transmission").
		/// </summary>
		public string SecurityCategory{
			get{
				return securityCategory;
			}
			set{
				securityCategory = value;
			}
		}

		/// <summary>
		/// State if the group is read only.
		/// </summary>
		public bool ReadOnly{
			get{
				return readOnly;
			}
			set{
				readOnly = value;
			}
		}

		/// <summary>
		/// Category of the group of entities. This is a String whose content is to be
		/// specified by the implementation.
		/// </summary>
		public string Category{
			get{
				return category;
			}
			set{
				category = value;
			}
		}

		/// <summary>
		/// The metadata for the units: distance, angle and so forth.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.GroupPayload.CoordinateUnits UnitsMetaData{
			get{
				return unitsMetaData;
			}
			set{
				unitsMetaData = value;
			}
		}

		/// <summary>
		/// List of the extension schema that may be used to define the key of the extended
		/// data of the entities of the group.
		/// </summary>
		public IEnumerable<Org.OMG.TACSIT.DataPayload.GroupPayload.ExtensionSchema> Schemas{
			get{
				return schemas;
			}
			set{
				schemas = value;
			}
		}

	}//end GroupMetaData

}//end namespace GroupPayload