///////////////////////////////////////////////////////////
//  GroupPayload.cs
//  Implementation of the Class GroupPayload
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 15:46:56
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.EntityPayload;
using Org.OMG.TACSIT.DataPayload.GroupPayload;
namespace Org.OMG.TACSIT.DataPayload.GroupPayload {
	/// <summary>
	/// The definition of a group of entities as it appears in the exchanges with
	/// TACSIT.
	/// 
	///        Note: the 'id' attribute is used by the TACSIT system to identify the
	/// GroupPayload when the 'identifier' attribute of the GroupMetatData is used by
	/// the system which requested the creation of this GroupPayload to identity
	/// internally it. 'identifier' is so a way to let this using system to find back
	/// its data when getting back the group from TACSIT.
	/// </summary>
	public class GroupPayload {

		private Uri id;
		private String version;
		private IEnumerable<Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef> entities;
		private IEnumerable<Org.OMG.TACSIT.DataPayload.GroupPayload.EntityRelationship> links;
		private Org.OMG.TACSIT.DataPayload.GroupPayload.GroupMetaData metaData;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public GroupPayload(){

		}

		/// <summary>
		/// Full Constructor with parameters for each property
		/// </summary>
		public GroupPayload(Uri the_id, String the_version, IEnumerable<Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef> the_entities, IEnumerable<Org.OMG.TACSIT.DataPayload.GroupPayload.EntityRelationship> the_links, Org.OMG.TACSIT.DataPayload.GroupPayload.GroupMetaData the_metaData){
			id = the_id;
			version = the_version;
			entities = the_entities;
			links = the_links;
			metaData = the_metaData;
		}

		/// <summary>
		/// Constructor with parameters for each mandatory property
		/// </summary>
		public GroupPayload(Uri the_id, String the_version, Org.OMG.TACSIT.DataPayload.GroupPayload.GroupMetaData the_metaData){
			id = the_id;
			version = the_version;
			metaData = the_metaData;
		}

		~GroupPayload(){

		}

		/// <summary>
		/// A Uniform Resource Identifier (URI) that uniquely identifies the object.
		/// </summary>
		public Uri Id{
			get{
				return id;
			}
			set{
				id = value;
			}
		}

		/// <summary>
		/// Version of the group.
		/// </summary>
		public string Version{
			get{
				return version;
			}
			set{
				version = value;
			}
		}

		/// <summary>
		/// List of references to Entities owned by the group.
		/// </summary>
		public IEnumerable<Org.OMG.TACSIT.DataPayload.EntityPayload.EntityRef> Entities{
			get{
				return entities;
			}
			set{
				entities = value;
			}
		}

		/// <summary>
		/// List of relationships among Entities owned by the group.
		/// </summary>
		public IEnumerable<Org.OMG.TACSIT.DataPayload.GroupPayload.EntityRelationship> Links{
			get{
				return links;
			}
			set{
				links = value;
			}
		}

		/// <summary>
		/// the (optional) metadata of a group.
		/// </summary>
		public Org.OMG.TACSIT.DataPayload.GroupPayload.GroupMetaData MetaData{
			get{
				return metaData;
			}
			set{
				metaData = value;
			}
		}

		/// <summary>
		/// Determine whether GroupPayload has a valid metaData property.
		/// </summary>
		public bool MetaDataExists(){

			return (metaData != null);
		}

	}//end GroupPayload

}//end namespace GroupPayload